VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AddIn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IDTExtensibility2
Dim oOutlook As Outlook.Application
Attribute oOutlook.VB_VarHelpID = -1
Dim WithEvents oItems As Outlook.Items
Attribute oItems.VB_VarHelpID = -1
Dim WithEvents oButton As Office.CommandBarButton
Attribute oButton.VB_VarHelpID = -1

Private Sub Initialize_handler()
    Set oItems = oOutlook.GetNamespace("MAPI").GetDefaultFolder(olFolderContacts).Items
    Set oButton = oOutlook.ActiveExplorer.CommandBars("Standard").Controls.Add(Temporary:=True)
    With oButton
        .Caption = "Update"
        .DescriptionText = "Update"
        .ToolTipText = "Save Contact Information to Database"
    End With
End Sub

Private Sub IDTExtensibility2_OnConnection(ByVal Application As Object, ByVal ConnectMode As AddInDesignerObjects.ext_ConnectMode, ByVal AddInInst As Object, custom() As Variant)
    Set oOutlook = Application
End Sub

Private Sub IDTExtensibility2_OnDisconnection(ByVal RemoveMode As AddInDesignerObjects.ext_DisconnectMode, custom() As Variant)
    Set oOutlook = Nothing
    Set oItems = Nothing
    Set oButton = Nothing
End Sub

Private Sub IDTExtensibility2_OnAddInsUpdate(custom() As Variant)
' Empty stub
End Sub

Private Sub IDTExtensibility2_OnBeginShutdown(custom() As Variant)
' Empty stub
End Sub

Private Sub IDTExtensibility2_OnStartupComplete(custom() As Variant)
    Initialize_handler
End Sub
Private Sub oItems_ItemAdd(ByVal Item As Object)
    Dim sPrompt As String
    
    sPrompt = "I see you've added " & Item & ".  Would you like this contact added to the database?"
    If MsgBox(sPrompt, vbYesNo + vbQuestion) = vbYes Then
        Call InsertContact(Item)
    End If
    
End Sub
Private Sub oButton_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
    Dim sPrompt As String
    Dim nCount As Integer
    
    nCount = oOutlook.ActiveExplorer.Selection.Count
    If nCount = 0 Then Exit Sub
    
    sPrompt = "Would you like to update these " & nCount & " item(s) to the database?"
    If MsgBox(sPrompt, vbYesNo + vbQuestion) = vbYes Then
        Call InsertContacts(oOutlook.ActiveExplorer.Selection)
    End If
End Sub

Private Sub InsertContacts(oItems As Object)
    Dim n As Integer
    Dim oContactItem As Object
    Dim oDatabase As Database
    Dim oRecordset As Recordset
    Dim sSQL As String
    Dim sFilePath As String
    
    sFilePath = App.Path & "\Ch07.mdb"
    Set oDatabase = OpenDatabase(sFilePath)
    Set oRecordset = oDatabase.OpenRecordset("Contact")
    For n = 1 To oItems.Count
        Set oContactItem = oItems.Item(n)
        MsgBox "Updating " & oContactItem & "..."
        With oRecordset
            .AddNew
            .Fields("Name").Value = oContactItem.FullName
            .Fields("Address").Value = oContactItem.BusinessAddressStreet
            .Fields("City").Value = oContactItem.BusinessAddressCity
            .Fields("State").Value = oContactItem.BusinessAddressState
            .Fields("Zip").Value = oContactItem.BusinessAddressPostalCode
            .Update
        End With
    Next n
    
    MsgBox "Update complete."
    
    oDatabase.Close
    Set oItems = Nothing
    Set oContactItem = Nothing
    Set oRecordset = Nothing
    Set oDatabase = Nothing
    
End Sub

Private Sub InsertContact(oItem As Object)
    Dim n As Integer
    Dim oContactItem As Object
    Dim oDatabase As Database
    Dim oRecordset As Recordset
    Dim sSQL As String
    Dim sFilePath As String
    
    sFilePath = App.Path & "\Ch07.mdb"
    Set oDatabase = OpenDatabase(sFilePath)
    Set oRecordset = oDatabase.OpenRecordset("Contact")
    Set oContactItem = oItem
    MsgBox "Updating " & oContactItem & "..."
    With oRecordset
        .AddNew
        .Fields("Name").Value = oContactItem.FullName
        .Fields("Address").Value = oContactItem.BusinessAddressStreet
        .Fields("City").Value = oContactItem.BusinessAddressCity
        .Fields("State").Value = oContactItem.BusinessAddressState
        .Fields("Zip").Value = oContactItem.BusinessAddressPostalCode
        .Update
    End With
    
    MsgBox "Update complete."
    oDatabase.Close
    Set oItem = Nothing
    Set oContactItem = Nothing
    Set oRecordset = Nothing
    Set oDatabase = Nothing
    
End Sub

