VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AddIn1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Chapter 15
' Simple COM add-in to add a toolbar button to Outlook, search a database, and create a Contact
'
Option Explicit

Implements IDTExtensibility2
Dim oOutlook As Outlook.Application
Attribute oOutlook.VB_VarHelpID = -1
Dim WithEvents oButton As Office.CommandBarButton
Attribute oButton.VB_VarHelpID = -1

Private Sub Initialize_handler()
'
' This routine adds the command bar button to the Standard menu bar
'
    Set oButton = oOutlook.ActiveExplorer.CommandBars("Standard").Controls.Add(Type:=msoControlButton, Temporary:=True)
    With oButton
        .Caption = "Search for contact"
        .FaceId = 607
        .DescriptionText = "Search"
        .Style = msoButtonIconAndCaption
        .ToolTipText = "Search for contact information in the main database"
    End With
End Sub

Private Sub IDTExtensibility2_OnConnection(ByVal Application As Object, ByVal ConnectMode As AddInDesignerObjects.ext_ConnectMode, ByVal AddInInst As Object, custom() As Variant)
'
' When Outlook starts, get a reference to the Outlook Application object
'
    Set oOutlook = Application
End Sub

Private Sub IDTExtensibility2_OnDisconnection(ByVal RemoveMode As AddInDesignerObjects.ext_DisconnectMode, custom() As Variant)
'
' When Outlook shuts down, destroy our internal objects
'
    Set oOutlook = Nothing
    Set oButton = Nothing
End Sub

Private Sub IDTExtensibility2_OnAddInsUpdate(custom() As Variant)
' Empty stub
End Sub

Private Sub IDTExtensibility2_OnBeginShutdown(custom() As Variant)
' Empty stub
End Sub

Private Sub IDTExtensibility2_OnStartupComplete(custom() As Variant)
'
' Outlook finished loading, so call command button add routine
'
    Initialize_handler
End Sub

Private Sub oButton_Click(ByVal Ctrl As Office.CommandBarButton, CancelDefault As Boolean)
'
' User clicked the button, so request a name
'
    Dim sName As String

    sName = InputBox("Search for contact: ", "Contact search")
    Call FindContact(sName)
End Sub


Private Sub FindContact(sName As String)
'
' Using the name supplied, look for the name in the database
'
    Dim n As Integer
    Dim oContactItem As Outlook.ContactItem
    Dim oInspector As Outlook.Inspector
    Dim oConnection As New ADODB.Connection
    Dim oRecordset As ADODB.Recordset
    Dim sSQL As String
    
    sSQL = "SELECT * FROM Contact WHERE Name LIKE '" & sName & "'"
    
    oConnection.Open "Contact"
    Set oRecordset = oConnection.Execute(sSQL)
    
    
    If (oRecordset.RecordCount = 0) Or (oRecordset.EOF) Then
        ' Not found
        MsgBox "Could not find " & sName
    Else
        ' Found, so create an Outlook contact item and fill it with the data from the database
        Set oContactItem = oOutlook.CreateItem(olContactItem)
        oRecordset.MoveFirst
        With oRecordset
            oContactItem.FullName = .Fields("Name").Value
            oContactItem.BusinessAddressStreet = .Fields("Address").Value
            oContactItem.BusinessAddressCity = .Fields("City").Value
            oContactItem.BusinessAddressState = .Fields("State").Value
            oContactItem.BusinessAddressPostalCode = .Fields("Zip").Value
            oContactItem.JobTitle = .Fields("Title").Value
            oContactItem.CompanyName = .Fields("Company").Value
            oContactItem.BusinessTelephoneNumber = .Fields("Phone").Value
            oContactItem.BusinessFaxNumber = .Fields("Fax").Value
            oContactItem.Email1Address = .Fields("Email").Value
            oContactItem.WebPage = .Fields("WebPage").Value
            oContactItem.Body = .Fields("Notes").Value
        End With
    
        ' Show the item in an Inspector window
        Set oInspector = oContactItem.GetInspector
        oInspector.Activate
    End If
    
    ' Clean up database connection
    oConnection.Close
    Set oRecordset = Nothing
    Set oConnection = Nothing
    
End Sub

