VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CDODataProvider"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Implements OLEDBSimpleProvider
Dim objListener As OLEDBSimpleProviderListener
Dim objListeners As New Collection

Public mFolderOnline As Boolean
Public cdoCollectionType As Integer
Public cdoSession As MAPI.Session
Public cdoFolder As MAPI.Folder
Public cdoMessages As MAPI.Messages
Public cdoFolders As MAPI.Folders
Public cdoHMessages As MAPI.Messages
Public cdoMessageFilter As MAPI.MessageFilter
Public cdoFields As MAPIFieldDetails
Private PrevRowCount As Long
Public Sub InitData()
Dim Listener As OLEDBSimpleProviderListener
Dim vListener As Variant
Dim NewRowCount As Long

    
    On Error Resume Next
    Err.Clear
    NewRowCount = 0
    If PrevRowCount > 0 Then
        For Each vListener In objListeners
            Set Listener = vListener
            Listener.aboutToDeleteRows 1, PrevRowCount
            Listener.deletedRows 1, PrevRowCount
        Next
    End If
    Select Case cdoCollectionType
        Case 1
            NewRowCount = cdoMessages.Count
        Case 2
            NewRowCount = cdoFolders.Count
        Case 3
            NewRowCount = cdoHMessages.Count
    End Select
    If NewRowCount > 0 Then
        For Each vListener In objListeners
            Listener.aboutToInsertRows 0, NewRowCount
            Listener.insertedRows 0, NewRowCount
        Next
    End If
    PrevRowCount = NewRowCount
    mFolderOnline = (Err.Number = 0)
End Sub
Private Sub Class_Initialize()
    
    On Error Resume Next
    mFolderOnline = False
    PrevRowCount = 0
    Set cdoFields = Nothing
    Set cdoMessages = Nothing
    Set cdoHMessages = Nothing
    Set cdoMessageFilter = Nothing
    Set cdoFolders = Nothing
    Set cdoSession = CreateObject("MAPI.Session")
End Sub
Private Sub Class_Terminate()
    
    On Error Resume Next
    cdoSession.Logoff
    Set cdoFields = Nothing
    Set cdoMessages = Nothing
    Set cdoMessageFilter = Nothing
    Set cdoFolders = Nothing
    Set cdoHMessages = Nothing
    Set cdoSession = Nothing
    Set objListeners = Nothing
End Sub
Function Get_Field_Value(iRow As Long, iColumn As Long) As Variant
Dim tmpMessage As MAPI.Message
Dim tmpFolder As MAPI.Folder
    
    On Error Resume Next
    Err.Clear
    If mFolderOnline Then
        If iRow = 0 Then
            Get_Field_Value = cdoFields(iColumn).DisplayName
        Else
            Select Case cdoCollectionType
                Case 1
                    Set tmpMessage = cdoMessages.Item(iRow)
                    Get_Field_Value = tmpMessage.Fields(cdoFields(iColumn).MAPIField)
                Case 2
                    Set tmpFolder = cdoFolders.Item(iRow)
                    Get_Field_Value = tmpFolder.Fields(cdoFields(iColumn).MAPIField)
                Case 3
                    Set tmpMessage = cdoHMessages.Item(iRow)
                    Get_Field_Value = tmpMessage.Fields(cdoFields(iColumn).MAPIField)
            End Select
        End If
        Set tmpMessage = Nothing
        Set tmpFolder = Nothing
    End If
End Function
Private Sub OLEDBSimpleProvider_addOLEDBSimpleProviderListener(ByVal pospIListener As OLEDBSimpleProviderListener)
    On Error Resume Next
    If Not (pospIListener Is Nothing) Then
        Set objListener = pospIListener
        objListeners.Add objListener
    End If
End Sub

Private Function OLEDBSimpleProvider_find(ByVal iRowStart As Long, ByVal iColumn As Long, ByVal val As Variant, ByVal findFlags As OSPFIND, ByVal compType As OSPCOMP) As Long
Dim StartingRow As Long
Dim EndingRow As Long
Dim FoundRow As Long
Dim iRow As Long
Dim StepValue As Long
Dim CaseSens As Integer
Dim StringComp As Integer
Dim CompResult As Integer
Dim CompValue As Variant

    If iRowStart < 1 Then iRowStart = 1
    If iRowStart > PrevRowCount Then iRowStart = PrevRowCount
    StartingRow = iRowStart
    If (findFlags And (OSPFIND_UP)) <> 0 Then
        EndingRow = 1
        StepValue = -1
    Else
        EndingRow = PrevRowCount
        StepValue = 1
    End If
    If (findFlags And (OSPFIND_CASESENSITIVE)) <> 0 Then
        CaseSens = 1
    Else
        CaseSens = 0
    End If
    If VarType(val) = vbString Then
        StringComp = True
    Else
        StringComp = False
    End If
    FoundRow = -1
    For iRow = StartingRow To EndingRow Step StepValue
        CompValue = Get_Field_Value(iRow, iColumn)
        If StringComp Then
            CompResult = StrComp(CompValue, val, CaseSens)
            Select Case (compType)
                Case OSPCOMP_DEFAULT, OSPCOMP_EQ:
                    If CompResult = 0 Then
                        FoundRow = iRow
                        Exit For
                    End If
                Case OSPCOMP_GE
                    If CompResult >= 0 Then
                        FoundRow = iRow
                        Exit For
                    End If
                Case OSPCOMP_GT
                    If CompResult > 0 Then
                        FoundRow = iRow
                        Exit For
                    End If
                Case OSPCOMP_LE
                    If CompResult <= 0 Then
                        FoundRow = iRow
                        Exit For
                    End If
                Case OSPCOMP_LT
                    If CompResult < 0 Then
                        FoundRow = iRow
                        Exit For
                    End If
                Case OSPCOMP_NE
                    If CompResult <> 0 Then
                        FoundRow = iRow
                        Exit For
                    End If
            End Select
        Else
            Select Case (compType)
                Case OSPCOMP_DEFAULT, OSPCOMP_EQ:
                    If CompValue = val Then
                        FoundRow = iRow
                        Exit For
                    End If
                Case OSPCOMP_GE
                    If CompValue >= val Then
                        FoundRow = iRow
                        Exit For
                    End If
                Case OSPCOMP_GT
                     If CompValue > val Then
                        FoundRow = iRow
                        Exit For
                    End If
                Case OSPCOMP_LE
                    If CompValue <= val Then
                        FoundRow = iRow
                        Exit For
                    End If
                Case OSPCOMP_LT
                    If CompValue < val Then
                        FoundRow = iRow
                        Exit For
                    End If
                Case OSPCOMP_NE
                    If CompValue <> val Then
                        FoundRow = iRow
                        Exit For
                    End If
            End Select
        End If
    Next iRow
    OLEDBSimpleProvider_find = FoundRow
End Function

Private Function OLEDBSimpleProvider_getColumnCount() As Long
    On Error Resume Next
    If mFolderOnline Then
        OLEDBSimpleProvider_getColumnCount = cdoFields.Count
    Else
        OLEDBSimpleProvider_getColumnCount = 0
    End If
End Function

Private Function OLEDBSimpleProvider_getEstimatedRows() As Long
     On Error Resume Next
     If mFolderOnline Then
         Select Case cdoCollectionType
            Case 1
                OLEDBSimpleProvider_getEstimatedRows = cdoMessages.Count
            Case 2
                OLEDBSimpleProvider_getEstimatedRows = cdoFolders.Count
            Case 3
                OLEDBSimpleProvider_getEstimatedRows = cdoHMessages.Count
        End Select
    Else
         OLEDBSimpleProvider_getEstimatedRows = 0
    End If
End Function

Private Function OLEDBSimpleProvider_getLocale() As String
    On Error Resume Next
    OLEDBSimpleProvider_getLocale = ""
End Function

Private Function OLEDBSimpleProvider_getRowCount() As Long
    On Error Resume Next
    If mFolderOnline Then
        Select Case cdoCollectionType
           Case 1
               OLEDBSimpleProvider_getRowCount = cdoMessages.Count
           Case 2
               OLEDBSimpleProvider_getRowCount = cdoFolders.Count
           Case 3
               OLEDBSimpleProvider_getRowCount = cdoHMessages.Count
        End Select
    Else
        OLEDBSimpleProvider_getRowCount = 0
    End If
End Function

Private Function OLEDBSimpleProvider_getRWStatus(ByVal iRow As Long, ByVal iColumn As Long) As OSPRW
    On Error Resume Next
    If mFolderOnline Then
        If cdoFields(iColumn).ReadOnly Then
            OLEDBSimpleProvider_getRWStatus = OSPRW_READONLY
        Else
            OLEDBSimpleProvider_getRWStatus = OSPRW_READWRITE
        End If
    Else
        OLEDBSimpleProvider_getRWStatus = OSPRW_READONLY
    End If
End Function
Private Function OLEDBSimpleProvider_getVariant(ByVal iRow As Long, ByVal iColumn As Long, ByVal format As OSPFORMAT) As Variant
    On Error Resume Next
    OLEDBSimpleProvider_getVariant = Get_Field_Value(iRow, iColumn)
End Function
Private Function OLEDBSimpleProvider_isAsync() As Long
    On Error Resume Next
    OLEDBSimpleProvider_isAsync = False
End Function
Private Sub OLEDBSimpleProvider_removeOLEDBSimpleProviderListener(ByVal pospIListener As OLEDBSimpleProviderListener)
Dim X As Integer
    
    On Error Resume Next
    For X = 1 To objListeners.Count
        If objListeners(X) Is pospIListener Then
            objListeners.Remove X
        End If
    Next
End Sub
Private Sub OLEDBSimpleProvider_setVariant(ByVal iRow As Long, ByVal iColumn As Long, ByVal format As OSPFORMAT, ByVal Var As Variant)
    ' not going to happen as we are read only
End Sub

Private Sub OLEDBSimpleProvider_stopTransfer()
    ' not going to happen as we are read only
End Sub
Private Function OLEDBSimpleProvider_deleteRows(ByVal iRow As Long, ByVal cRows As Long) As Long
    ' not going to happen as we are read only
End Function
Private Function OLEDBSimpleProvider_insertRows(ByVal iRow As Long, ByVal cRows As Long) As Long
    ' not going to happen as we are read only
End Function

