VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 1  'vbDataSource
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CDODataSource"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Dim SQLSelect As String
Dim Credentials() As String
Dim SQLFrom As String
Dim SQLWhere As String
Dim SQLOrderBy As String
Dim FolderNames() As String
Dim FieldNames() As String
Dim ErrorString As String

Dim CDOOSP As CDODataProvider
Private Sub Class_GetDataMember(DataMember As String, Data As Object)
Dim tmpInfoStore As MAPI.InfoStore
Dim cdoRootFolder As MAPI.Folder
Dim cdoFolder As MAPI.Folder
Dim tmpFolders As MAPI.Folders
Dim tmpFolder As MAPI.Folder
Dim SelectObjectType As Integer
Dim X, Y As Integer
Dim RootFolderOK As Boolean
 
    On Error GoTo ERRORFAIL
    ParseSQL DataMember, SQLSelect, SQLFrom, SQLWhere, SQLOrderBy
    If (Trim(SQLSelect) = "") Or (Trim(SQLFrom) = "") Then
        ErrorString = "Could not parse SQL string:" & DataMember
        GoTo ERRORFAIL
    End If
    SQLFrom = Replace(SQLFrom, "'", "")
    FolderNames = Split(SQLFrom, "\")
    If UBound(FolderNames) < 1 Then
        ErrorString = "Invalid Folder Specified in SELECT:" & SQLFrom
        GoTo ERRORFAIL
    End If
    If InStr(FolderNames(0), "..") > 0 Then
        Credentials = Split(FolderNames(0), ".")
        For X = 1 To UBound(FolderNames)
            FolderNames(X - 1) = FolderNames(X)
        Next
        ReDim Preserve FolderNames(UBound(FolderNames) - 1)
    Else
        ReDim Credentials(3)
    End If
    SelectObjectType = 1
    If InStrRev(UCase(FolderNames(UBound(FolderNames))), ".FOLDERS") >= 1 Then
        FolderNames(UBound(FolderNames)) = Mid(FolderNames(UBound(FolderNames)), 1, (InStrRev(UCase(FolderNames(UBound(FolderNames))), ".FOLDERS") - 1))
        If Trim(FolderNames(UBound(FolderNames))) = "" Then ReDim Preserve FolderNames(UBound(FolderNames) - 1)
        SelectObjectType = 2
    End If
    If InStrRev(UCase(FolderNames(UBound(FolderNames))), ".HIDDENMESSAGES") >= 1 Then
        FolderNames(UBound(FolderNames)) = Mid(FolderNames(UBound(FolderNames)), 1, (InStrRev(UCase(FolderNames(UBound(FolderNames))), ".HIDDENMESSAGES") - 1))
        If Trim(FolderNames(UBound(FolderNames))) = "" Then ReDim Preserve FolderNames(UBound(FolderNames) - 1)
        SelectObjectType = 3
    End If
    If CDOOSP Is Nothing Then
        Set CDOOSP = New CDODataProvider
        CDOOSP.cdoCollectionType = SelectObjectType
        If CDOOSP.cdoSession Is Nothing Then
            ErrorString = "Could not get/find MAPI"
            GoTo ERRORFAIL
        End If
        If Trim(SQLSelect) = "*" Then
            Select Case CDOOSP.cdoCollectionType
                Case 1, 3
                    SQLSelect = "subject,sender,recipients,timereceived"
                Case 2
                    SQLSelect = "name," & CdoPR_ENTRYID
            End Select
        End If
        FieldNames = Split(SQLSelect, ",")
        If FieldNames(0) = "" Then
                ErrorString = "No Fields Specified in SELECT"
                GoTo ERRORFAIL
        End If
        Set CDOOSP.cdoFields = New MAPIFieldDetails
        For X = 0 To UBound(FieldNames)
            CDOOSP.cdoFields.Add CStr(X), Replace(FieldNames(X), "'", "")
        Next
        If Trim(Credentials(0)) = "" Then
            CDOOSP.cdoSession.Logon , , False, False, -1, True
        Else
            CDOOSP.cdoSession.Logon , , , True, , True, Credentials(0) & vbLf & Credentials(2)
        End If
    End If
    
    RootFolderOK = False
    For Each tmpInfoStore In CDOOSP.cdoSession.InfoStores
        If InStr(UCase(tmpInfoStore.Name), UCase(FolderNames(0))) = 1 Then
            Set cdoRootFolder = tmpInfoStore.RootFolder
            RootFolderOK = True
            Exit For
        End If
    Next
    If cdoRootFolder Is Nothing Then
        ErrorString = "Could not find Information Store:" & FolderNames(0)
        GoTo ERRORFAIL
    End If
    

    Set cdoFolder = cdoRootFolder
        
    For X = 0 To UBound(FolderNames)
        Set tmpFolders = cdoFolder.Folders
        For Each tmpFolder In tmpFolders
            If Trim(UCase(tmpFolder.Name)) = Trim(UCase(FolderNames(X))) Then
                Set cdoFolder = tmpFolder
                Exit For
            End If
        Next
    Next

    If (UBound(FolderNames) = 0 And RootFolderOK) Or (Trim(UCase(cdoFolder.Name)) = Trim(UCase(FolderNames(UBound(FolderNames))))) Then
        Set CDOOSP.cdoMessages = cdoFolder.Messages
        Set CDOOSP.cdoMessageFilter = CDOOSP.cdoMessages.Filter
        Set CDOOSP.cdoFolders = cdoFolder.Folders
        Set CDOOSP.cdoHMessages = cdoFolder.HiddenMessages
    Else
        ErrorString = "Could not Find Folder " & SQLFrom
        GoTo ERRORFAIL
    End If
    SetFilter SQLWhere
    SetOrder SQLOrderBy
    
    CDOOSP.InitData
    
    Set Data = CDOOSP
    Exit Sub
    
ERRORFAIL:
    If ErrorString = "" Then ErrorString = Err.Description
    Set Data = Nothing
    Set CDOOSP = Nothing
    Err.Raise E_FAIL, "MAPI Data Provider", ErrorString
End Sub
Private Function Split(BigString, chrDelimiter)
Dim InfoArray() As String
Dim strTemp As String
Dim chrTemp As String
Dim intCount As Integer
Dim posPrev As Integer
Dim posNext As Integer
Dim intLoop As Integer

    On Error Resume Next
    strTemp = Trim(BigString)
    intCount = 0
    posPrev = 1
    ReDim InfoArray(intCount)
    If InStr(strTemp, chrDelimiter) = 1 Then strTemp = Mid(strTemp, 2)
    If Mid(strTemp, Len(strTemp)) = chrDelimiter Then strTemp = Mid(strTemp, 1, Len(strTemp) - 1)
    If Len(strTemp) = 0 Then
        InfoArray(intCount) = strTemp
        Split = InfoArray
        Exit Function
    End If
    If InStr(strTemp, chrDelimiter) = 0 Then
        InfoArray(intCount) = Trim(strTemp)
        Split = InfoArray
        Exit Function
    End If
    For intLoop = 1 To Len(strTemp)
        If Mid(strTemp, intLoop, 1) = chrDelimiter Then
            ReDim Preserve InfoArray(intCount)
            InfoArray(intCount) = Trim(Mid(strTemp, posPrev, (intLoop - posPrev)))
            posPrev = intLoop + 1
            intCount = intCount + 1
        End If
    Next
    ReDim Preserve InfoArray(intCount)
    InfoArray(intCount) = Trim(Mid(strTemp, posPrev, (intLoop - posPrev)))
    Split = InfoArray
End Function

Private Sub ParseSQL(SQLCommandString As String, strSelect As String, strFrom As String, strWhere As String, strOrderBy As String)
Dim sqlStr As String
Dim posSelect As Integer
Dim posFrom As Integer
Dim posWhere As Integer
Dim posOrder As Integer
Dim posStr As Integer

    On Error Resume Next
    strFrom = ""
    strSelect = ""
    strWhere = ""
    strOrderBy = ""
    sqlStr = Trim(SQLCommandString)
    posSelect = InStr(UCase(sqlStr), "SELECT")
    posFrom = InStr(UCase(sqlStr), "FROM")
    posWhere = InStr(UCase(sqlStr), "WHERE")
    posOrder = InStr(UCase(sqlStr), "ORDER BY")
    If posSelect > 0 Then strSelect = Trim(Mid(sqlStr, posSelect + 7))
    If InStr(UCase(strSelect), "FROM") > 0 Then strSelect = Trim(Mid(strSelect, 1, InStr(UCase(strSelect), "FROM") - 1))
    If posFrom > 0 Then strFrom = Trim(Mid(sqlStr, posFrom + 4))
    If InStr(UCase(strFrom), "WHERE") > 0 Then strFrom = Trim(Mid(strFrom, 1, InStr(UCase(strFrom), "WHERE") - 1))
    If InStr(UCase(strFrom), "ORDER BY") > 0 Then strFrom = Trim(Mid(strFrom, 1, InStr(UCase(strFrom), "ORDER BY") - 1))
    If posWhere > 0 Then strWhere = Trim(Mid(sqlStr, posWhere + 5))
    If InStr(UCase(strWhere), "ORDER BY") > 0 Then strWhere = Trim(Mid(strWhere, 1, InStr(UCase(strWhere), "ORDER BY") - 1))
    If posOrder > 0 Then strOrderBy = Trim(Mid(sqlStr, posOrder + 8))
End Sub
Private Sub SetFilter(ByVal SQLWhereString)
Dim WhereClauses() As String
Dim WhereClause() As String
Dim strWhereString As String
Dim X, Y As Integer

    On Error GoTo WhereError
    If InStr(LCase(SQLWhereString), " like ") > 0 Then GoTo WhereError
    If InStr(LCase(SQLWhereString), ">") > 0 Then GoTo WhereError
    If InStr(LCase(SQLWhereString), "<") > 0 Then GoTo WhereError
    While InStr(LCase(SQLWhereString), " and ") > 0
        SQLWhereString = Replace(SQLWhereString, " and ", "^")
        SQLWhereString = Replace((SQLWhereString), " AND ", "^")
        SQLWhereString = Replace((SQLWhereString), " And ", "^")
    Wend
    If (InStr(SQLWhereString, "^") = 0) And (InStr(LCase(SQLWhereString), " or ") > 0) Then
        CDOOSP.cdoMessageFilter.Or = True
        SQLWhereString = Replace(SQLWhereString, " or ", "^")
        SQLWhereString = Replace((SQLWhereString), " OR ", "^")
        SQLWhereString = Replace((SQLWhereString), " Or ", "^")
        SQLWhereString = Replace((SQLWhereString), " oR ", "^")
    End If
    WhereClauses = Split(SQLWhereString, "^")
    For X = 0 To UBound(WhereClauses)
        WhereClause = Split(WhereClauses(X), "=")
        If UBound(WhereClause) = 1 Then
            Set_Filter WhereClause(0), WhereClause(1)
        End If
    Next
    Exit Sub

WhereError:
    ErrorString = "Error parsing WHERE filter:" & SQLWhereString
    Exit Sub
End Sub
Private Sub Set_Filter(FilterField, FilterValue)
Dim objField As Object
        
    On Error GoTo WhereError
    If FilterField = "" Then Exit Sub
    If IsNumeric(FilterField) Then
        Set objField = CDOOSP.cdoMessageFilter.Fields.Add(FilterField, FilterValue)
    Else
        FilterField = Replace(FilterField, "'", "")
        FilterValue = Replace(FilterValue, "'", "")
        Select Case UCase(FilterField)
            Case "TYPE"
                CDOOSP.cdoMessageFilter.Type = FilterValue
            Case "CONVERSATION"
                CDOOSP.cdoMessageFilter.Conversation = FilterValue
            Case "SUBJECT"
                CDOOSP.cdoMessageFilter.Subject = FilterValue
            Case "TEXT"
                CDOOSP.cdoMessageFilter.Text = FilterValue
            Case "UNREAD"
                CDOOSP.cdoMessageFilter.Unread = FilterValue
            Case "RECIPIENTS"
                CDOOSP.cdoMessageFilter.Recipients = FilterValue
            Case "SENDER"
                CDOOSP.cdoMessageFilter.Sender = FilterValue
            Case "SENT"
                CDOOSP.cdoMessageFilter.Sent = FilterValue
            Case "SIZE"
                CDOOSP.cdoMessageFilter.Size = FilterValue
            Case "TIMEFIRST"
                CDOOSP.cdoMessageFilter.TimeFirst = FilterValue
            Case "TIMELAST"
                CDOOSP.cdoMessageFilter.TimeLast = FilterValue
            Case Else
                Set objField = CDOOSP.cdoMessageFilter.Fields.Add(FilterField, VarType(FilterValue), FilterValue)
        End Select
    End If
    Exit Sub
    
WhereError:
    ErrorString = "Error setting WHERE filter:" & FilterField & "=" & FilterValue
    Exit Sub
End Sub
Private Sub SetOrder(ByVal SQLOrderBy)
Dim OrderClause As Variant
Dim SortOrder As Integer
Dim objMessage As MAPI.Message
Dim OrderFields As MAPIFieldDetails
Dim OrderByField As MAPIField
    
 
    On Error GoTo OrderError:
    SortOrder = 1
    If InStr(LCase(SQLOrderBy), " asc") > 0 Then
        SortOrder = 1
        SQLOrderBy = Trim(Mid(SQLOrderBy, 1, InStr(LCase(SQLOrderBy), " asc")))
    End If
    If InStr(LCase(SQLOrderBy), " desc") > 0 Then
        SortOrder = 2
        SQLOrderBy = Trim(Mid(SQLOrderBy, 1, InStr(LCase(SQLOrderBy), " desc")))
    End If
    If SQLOrderBy = "" Then Exit Sub
    Set OrderFields = New MAPIFieldDetails
    OrderClause = Trim(SQLOrderBy)
    OrderFields.Add "0", OrderClause
    Set OrderByField = OrderFields(1)
    If OrderByField.SortField <> "" Then CDOOSP.cdoMessages.Sort SortOrder, OrderByField.SortField
    Set OrderByField = Nothing
    Set OrderFields = Nothing
    Exit Sub
    
OrderError:
    ErrorString = "Error Sorting Messages:" & SQLOrderBy
    Exit Sub
End Sub

