VERSION 1.0 CLASS
BEGIN
  MultiUse = 0   'False
END
Attribute VB_Name = "clsRegistryAgent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable(s) to hold property value(s)
Private mlhKey As Long
Private msRegistryKey As String
Private msSubKey As String
Private mvValue As Variant
Private mlStatus As Long

Private Const HKEY_CLASSES_ROOT As Long = &H80000000
Private Const HKEY_CURRENT_USER As Long = &H80000001
Private Const HKEY_LOCAL_MACHINE As Long = &H80000002
Private Const HKEY_USERS As Long = &H80000003
Private Const HKEY_DYN_DATA As Long = &H80000004

Private Const REG_SZ As Long = 1
Private Const REG_BINARY As Long = 3
Private Const REG_DWORD As Long = 4

Private Const REG_OPTION_NON_VOLATILE As Long = 0      ' Key is preserved when system is rebooted
Private Const REG_OPTION_BACKUP_RESTORE As Long = 4    ' open for backup or restore
Private Const REG_OPTION_CREATE_LINK As Long = 2       ' Created key is a symbolic link
Private Const REG_OPTION_VOLATILE As Long = 1          ' Key is not preserved when system is rebooted

Private Const KEY_QUERY_VALUE As Long = &H1
Private Const KEY_SET_VALUE As Long = &H2
Private Const KEY_CREATE_LINK As Long = &H20
Private Const KEY_CREATE_SUB_KEY As Long = &H4
Private Const KEY_ENUMERATE_SUB_KEYS As Long = &H8
Private Const KEY_NOTIFY As Long = &H10

Private Const SYNCHRONIZE As Long = &H100000
Private Const STANDARD_RIGHTS_ALL As Long = &H1F0000
Private Const KEY_ALL_ACCESS As Long = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE _
    Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or _
    KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))

Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" _
    (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, _
    ByVal lpClass As String, ByVal dwOptions As Long, _
    ByVal samDesired As Long, lpSecurityAttributes As Long, _
    phkResult As Long, lpdwDisposition As Long) As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" _
    (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, _
    ByVal samDesired As Long, phkResult As Long) As Long

Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" _
    (ByVal hKey As Long, _
     ByVal lpSubKey As String) As Long
     
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" _
    (ByVal hKey As Long, _
     ByVal lpSubKey As String) As Long
     
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" _
    (ByVal hKey As Long, _
     ByVal lpValueName As String, _
     ByVal lpReserved As Long, _
     lpType As Long, _
     lpData As Any, _
     lpcbData As Long) As Long
     
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" _
    (ByVal hKey As Long, _
     ByVal lpValueName As String, _
     ByVal Reserved As Long, _
     ByVal dwType As Long, _
     lpData As Any, _
     ByVal cbData As Long) As Long

Private Const ERROR_SUCCESS As Long = 0&
Private Const ERROR_BADDB As Long = 1009&
Private Const ERROR_BADKEY As Long = 1010&
Private Const ERROR_CANTOPEN As Long = 1011&
Private Const ERROR_CANTREAD As Long = 1012&
Private Const ERROR_CANTWRITE As Long = 1013&
Private Const ERROR_REGISTRY_RECOVERED As Long = 1014&
Private Const ERROR_REGISTRY_CORRUPT As Long = 1015&
Private Const ERROR_REGISTRY_IO_FAILED As Long = 1016&
Private Const ERROR_NOT_REGISTRY_FILE As Long = 1017&
Private Const ERROR_KEY_DELETED As Long = 1018&
Private Const ERROR_NO_LOG_SPACE As Long = 1019&
Private Const ERROR_KEY_HAS_CHILDREN As Long = 1020&
Private Const ERROR_CHILD_MUST_BE_VOLATILE As Long = 1021&
Private Const ERROR_RXACT_INVALID_STATE As Long = 1369&

Private Const REGAGENT_NOKEY As Long = -1002
Private Const REGAGENT_NOSUBKEY As Long = -1003
Public Property Let hKey(ByVal lData As Long)
    mlhKey = lData
End Property


Public Property Get hKey() As Long
    hKey = mlhKey
End Property

Public Sub CreateKey()
    Dim lRetVal         As Long
    Dim lKeyID          As Long
    
    mlStatus = 0
    If Len(msRegistryKey) = 0 Or mlhKey = 0 Then
        mlStatus = REGAGENT_NOKEY
        Exit Sub
    End If
    
    mlStatus = RegCreateKeyEx(mlhKey, msRegistryKey, 0&, _
    vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, ByVal 0&, lKeyID, _
    lRetVal)
    
    RegCloseKey (lKeyID)
    
End Sub

Public Sub DeleteKey()
    
Dim lKeyID          As Long
Dim lRetVal         As Long
    
    mlStatus = 0
    If Len(msRegistryKey) = 0 Or mlhKey = 0 Then
        mlStatus = REGAGENT_NOKEY
        Exit Sub
    End If
    
    If mlStatus = 0 Then
        mlStatus = RegDeleteKey(mlhKey, ByVal msRegistryKey)
    End If
    
End Sub

Public Sub DeleteValue()

Dim lKeyID          As Long
Dim lRetVal         As Long

    mlStatus = 0
    If Len(msRegistryKey) = 0 Or mlhKey = 0 Then
        mlStatus = REGAGENT_NOKEY
        Exit Sub
    End If
    If Len(msSubKey) = 0 Then
        mlStatus = REGAGENT_NOSUBKEY
        Exit Sub
    End If
    
    mlStatus = RegOpenKeyEx(mlhKey, msRegistryKey, 0&, _
        KEY_ALL_ACCESS, lKeyID)
        
    If mlStatus = ERROR_SUCCESS Then
        mlStatus = RegDeleteValue(lKeyID, ByVal msSubKey)
    End If
    
    RegCloseKey (lKeyID)
    
End Sub

Public Function GetErrorText() As String

Select Case mlStatus
  Case REGAGENT_NOKEY
    GetErrorText = "You have not provided a registry key."
    
  Case REGAGENT_NOSUBKEY
    GetErrorText = "You have not provided a sub key."
    
  Case ERROR_BADDB
    GetErrorText = "The configuration registry database is corrupt."
    
  Case ERROR_BADKEY
    GetErrorText = "The configuration registry key is invalid."
    
  Case ERROR_CANTOPEN
    GetErrorText = "The configuration registry key could not be opened."
    
  Case ERROR_CANTREAD
    GetErrorText = "The configuration registry key could not be read."
    
  Case ERROR_CANTWRITE
    GetErrorText = "The configuration registry key could not be written."
    
  Case ERROR_REGISTRY_RECOVERED
    GetErrorText = "One of the files in the Registry database had to be recovered " & _
                   "by use of a log or alternate copy. The recovery was successful."
                   
  Case ERROR_REGISTRY_CORRUPT
    GetErrorText = "The Registry is corrupt. The structure of one of the files that contains " & _
                   "Registry data is corrupt, or the system's image of the file in memory " & _
                   "is corrupt, or the file could not be recovered because the alternate " & _
                   "copy or log was absent or corrupt."
                   
  Case ERROR_REGISTRY_IO_FAILED
    GetErrorText = "An I/O operation initiated by the Registry failed unrecoverably. " & _
                   "The Registry could not read in, or write out, or flush, one of the files " & _
                   "that contain the system's image of the Registry."
                   
  Case ERROR_NOT_REGISTRY_FILE
    GetErrorText = "The system has attempted to load or restore a file into the Registry, but the " & _
                   "specified file is not in a Registry file format."
                   
  Case ERROR_KEY_DELETED
    GetErrorText = "Illegal operation attempted on a Registry key which has been marked for deletion."
    
  Case ERROR_NO_LOG_SPACE
    GetErrorText = "System could not allocate the required space in a Registry log."
    
  Case ERROR_KEY_HAS_CHILDREN
    GetErrorText = "Cannot create a symbolic link in a Registry key that already " & _
                   "has subkeys or values."
                   
  Case ERROR_CHILD_MUST_BE_VOLATILE
    GetErrorText = "Cannot create a stable subkey under a volatile parent key."
    
  Case ERROR_RXACT_INVALID_STATE
    GetErrorText = "The transaction state of a Registry subtree is incompatible with the " & _
                   "requested operation."
                   
End Select

End Function

Public Sub GetStringValue()
    '10/01/1997         C.Gallo         Changed mid() to mid$() and hex() to hex$()

    Dim lResult As Long
    Dim lKeyID As Long
    Dim lValueType As Long
    Dim lBufferSize As Long
    Dim sTemp As String
    Dim i As Integer

    mlStatus = 0
    mvValue = Empty
    
    If Len(msRegistryKey) = 0 Or mlhKey = 0 Then
        mlStatus = REGAGENT_NOKEY
        Exit Sub
    End If
    
    mlStatus = RegOpenKeyEx(mlhKey, msRegistryKey, 0&, _
        KEY_ALL_ACCESS, lKeyID)
    
    If mlStatus <> 0 Then
        Exit Sub
    End If
    
    lBufferSize = 1024
    sTemp = String$(1024, 0)
    
    mlStatus = RegQueryValueEx(lKeyID, msSubKey, 0&, lValueType, ByVal sTemp, lBufferSize)
    If mlStatus <> 0 Then
        Exit Sub
    End If
    
    If lBufferSize <> 0 Then
        If (Asc(Mid$(sTemp, lBufferSize, 1)) = 0) Then           ' Win95 Adds Null Terminated String...
            sTemp = Left$(sTemp, lBufferSize - 1)               ' Null Found, Extract From String
        Else                                                    ' WinNT Does NOT Null Terminate String...
            sTemp = Left$(sTemp, lBufferSize)                   ' Null Not Found, Extract String Only
        End If
    Else
        sTemp = ""
    End If
    
    Select Case lValueType                                  ' Search Data Types...
    Case REG_SZ                                             ' String Registry Key Data Type
        mvValue = sTemp                                     ' Copy String Value
    Case REG_DWORD                                          ' Double Word Registry Key Data Type
        For i = Len(sTemp) To 1 Step -1                     ' Convert Each Bit
            mvValue = mvValue + Hex$(Asc(Mid$(sTemp, i, 1)))  ' Build Value Char. By Char.
        Next
        mvValue = Format$("&h" + mvValue)                   ' Convert Double Word To String
    End Select
    
    RegCloseKey (lKeyID)

End Sub


Property Get RegistryKey() As String
    RegistryKey = msRegistryKey
End Property



Property Let RegistryKey(sKey As String)
    msRegistryKey = sKey
End Property


Property Let Value(sValue As Variant)
    mvValue = sValue
End Property


Property Get Value() As Variant
    Value = mvValue
End Property



Public Sub SetStringValue()

    Dim lKeyID As Long
    Dim lRetVal As Long
    Dim sTemp As String

    mlStatus = 0

    sTemp = Trim$(CStr(mvValue))

    If Len(msRegistryKey) = 0 Or mlhKey = 0 Then
        mlStatus = REGAGENT_NOKEY
        Exit Sub
    End If
    
    'Open or Create key
    mlStatus = RegCreateKeyEx(mlhKey, msRegistryKey, 0&, vbNullString, REG_OPTION_NON_VOLATILE, _
        KEY_ALL_ACCESS, ByVal 0&, lKeyID, lRetVal)
    
    If mlStatus <> ERROR_SUCCESS Then
        Exit Sub
    End If
    
    If sTemp = "" Then
        mlStatus = RegSetValueEx(lKeyID, msSubKey, 0&, REG_SZ, ByVal sTemp, 0)
    Else
        mlStatus = RegSetValueEx(lKeyID, msSubKey, 0&, REG_SZ, ByVal sTemp, Len(sTemp) + 1)
    End If
    
    RegCloseKey (lKeyID)

End Sub
Property Get Status() As Long
    Status = mlStatus
End Property


Property Get SubKey() As String
    SubKey = msSubKey
End Property

Property Let SubKey(sSubKeyValue As String)
    msSubKey = sSubKeyValue
End Property



Public Sub SetNumericValue()

    Dim lKeyID As Long
    Dim lRetVal As Long
    Dim lData As Long
    
    Const BUFFERSIZE As Long = 4
    
    mlStatus = 0
    If IsNumeric(mvValue) Then
        lData = mvValue
    Else
        Exit Sub
    End If
    
    If Len(msRegistryKey) = 0 Or mlhKey = 0 Then
        mlStatus = REGAGENT_NOKEY
        Exit Sub
    End If
    
    'Open or create key
    mlStatus = RegCreateKeyEx(mlhKey, msRegistryKey, 0&, _
        vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, ByVal 0&, lKeyID, _
        lRetVal)
    
    If mlStatus <> ERROR_SUCCESS Then
        Exit Sub
    End If
    
    mlStatus = RegSetValueEx(lKeyID, msSubKey, 0&, REG_DWORD, lData, _
                BUFFERSIZE)
    
    RegCloseKey (lKeyID)

End Sub

Public Sub GetNumericValue()

    Dim lResult As Long
    Dim lKeyID As Long
    Dim lValueType As Long
    Dim lBufferSize As Long
    Dim lTemp As Long

    mlStatus = 0
    mvValue = Empty
    
    If Len(msRegistryKey) = 0 Or mlhKey = 0 Then
        mlStatus = REGAGENT_NOKEY
        Exit Sub
    End If
    
    mlStatus = RegOpenKeyEx(mlhKey, msRegistryKey, 0&, _
        KEY_ALL_ACCESS, lKeyID)
    
    If mlStatus <> 0 Then
        Exit Sub
    End If
    
    lBufferSize = 4
    
    mlStatus = RegQueryValueEx(lKeyID, msSubKey, 0&, lValueType, lTemp, lBufferSize)
    If mlStatus <> 0 Then
        Exit Sub
    End If
    
    If lValueType = REG_DWORD Then
        mvValue = lTemp
    End If
    
    RegCloseKey (lKeyID)

End Sub
