VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsResource"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'------------------------------------------------------------------------------------------------------
'  Developing Applications using Outlook 2000, CDO, Exchange, and Visual Basic
'------------------------------------------------------------------------------------------------------
'Section        Comment Description
'
'Purpose        Resource/Recipient class.  Each person in a particular group is
'               represented by an instance of this class.
'------------------------------------------------------------------------------------------------------
'   Revision History:
'   Date:       Developer:                  Description:
'------------------------------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------------
' Declarations:
Private msFullName As String        ' First and last name
Private msAlias As String           ' Username (e.g. SMITHJ)
Private mvKey As Variant            ' Key in the Resources collection
Private mlisResource As ListBox     ' List box in the UI connected to this person

Public Sub Construct(lisResource As ListBox)
'------------------------------------------------------------------------------------------------------
'  Developing Applications using Outlook 2000, CDO, Exchange, and Visual Basic
'------------------------------------------------------------------------------------------------------
'Section        Comment Description
'
'Purpose        Constructor for the class.  Since VB Intialize event does not
'               accept parameters, call this after each instantiation of the class.
'Inputs         lisResource - List box in the UI
'------------------------------------------------------------------------------------------------------
'   Revision History:
'   Date:       Developer:                  Description:
'------------------------------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------------

  Set mlisResource = lisResource

End Sub

Public Property Let FullName(sName As String)

  msFullName = sName

End Property

Public Property Get FullName() As String

  FullName = msFullName

End Property

Public Property Let Alias(sAlias As String)

  msAlias = sAlias

End Property

Public Property Get Alias() As String

  Alias = msAlias

End Property

Public Property Get ListBoxIndex() As Long
'------------------------------------------------------------------------------------------------------
'  Developing Applications using Outlook 2000, CDO, Exchange, and Visual Basic
'------------------------------------------------------------------------------------------------------
'Section        Comment Description
'
'Purpose        Find which ListIndex this Resource is in the ListBox
'Inputs         None
'Assumes        The Resource is actually in the list and that lis.ItemData contains
'               the key number of this resource (see comments in code)
'Returns        Listbox Index of Resource
'------------------------------------------------------------------------------------------------------
'   Revision History:
'   Date:       Developer:                  Description:
'------------------------------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------------
' Declarations:
Dim lLoop As Long
Dim lOut As Long
  
  On Error GoTo ListBoxIndex_Error
  lOut = -1
  
  ' It goes through each item in list box
  For lLoop = 0 To mlisResource.ListCount - 1
    ' The ItemData should contain the key value for this resource
    ' (e.g. if key = "K9" then we're looking for the value 9)
    If mlisResource.ItemData(lLoop) = Mid(mvKey, 2) Then
      lOut = lLoop
      Exit For
    End If
  Next lLoop
  
ListBoxIndex_Exit:
  ListBoxIndex = lOut
  Exit Property

ListBoxIndex_Error:
  lOut = -1
  Resume ListBoxIndex_Exit

End Property

Public Property Let Key(vKey As Variant)

  mvKey = vKey

End Property

Public Property Get Key() As Variant

  Key = mvKey

End Property

Public Property Get DisplayName() As String
'------------------------------------------------------------------------------------------------------
'  Developing Applications using Outlook 2000, CDO, Exchange, and Visual Basic
'------------------------------------------------------------------------------------------------------
'Section        Comment Description
'
'Purpose        What is shown visibly in the list box
'------------------------------------------------------------------------------------------------------
'   Revision History:
'   Date:       Developer:                  Description:
'------------------------------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------------
Dim lIndex As Long
  
  On Error GoTo DisplayName_Error

  lIndex = ListBoxIndex()
  If lIndex > -1 Then
    DisplayName = mlisResource.List(lIndex)
  Else
    DisplayName = False
  End If

DisplayName_Exit:
  Exit Property

DisplayName_Error:
  DisplayName = False
  Resume DisplayName_Exit

End Property

Public Property Get Selected() As Boolean
'------------------------------------------------------------------------------------------------------
'  Developing Applications using Outlook 2000, CDO, Exchange, and Visual Basic
'------------------------------------------------------------------------------------------------------
'Section        Comment Description
'
'Purpose        Whether the resource is selected in the list box
'Returns        True = Selected, False = Not Selected
'------------------------------------------------------------------------------------------------------
'   Revision History:
'   Date:       Developer:                  Description:
'------------------------------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------------
Dim lIndex As Long
  
  On Error GoTo Selected_Error

  lIndex = ListBoxIndex()
  If lIndex > -1 Then
    Selected = mlisResource.Selected(lIndex)
  Else
    Selected = False
  End If

Selected_Exit:
  Exit Property

Selected_Error:
  Selected = False
  Resume Selected_Exit

End Property

