VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsResources"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsResource"
Attribute VB_Ext_KEY = "Member0" ,"clsResource"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'------------------------------------------------------------------------------------------------------
'  Developing Applications using Outlook 2000, CDO, Exchange, and Visual Basic
'------------------------------------------------------------------------------------------------------
'Section        Comment Description
'
'Purpose        Resource collection class.
'------------------------------------------------------------------------------------------------------
'   Revision History:
'   Date:       Developer:                  Description:
'------------------------------------------------------------------------------------------------------
'
'------------------------------------------------------------------------------------
' Declarations:
Private mCol As Collection        ' Collection of resource objects
Private mlisResource As ListBox   ' List box in UI that corresponds to this list

Private mnKey As Integer          ' Key for next resource added

Public Function Add(sFullName As String) As clsResource
  
Dim oNewMember As clsResource
  
  ' Create a new object
  Set oNewMember = New clsResource
  Call oNewMember.Construct(mlisResource)

  ' Set the properties passed into the method
  mnKey = mnKey + 1
  mCol.Add oNewMember, "K" & mnKey

  oNewMember.FullName = sFullName
  
  mlisResource.AddItem sFullName
  oNewMember.Key = "K" & mnKey
  mlisResource.ItemData(mlisResource.NewIndex) = mnKey
    
  ' Return the object created
  Set Add = oNewMember
  Set oNewMember = Nothing

End Function

Public Property Get Item(vIndexKey As Variant) As clsResource
  
  On Error Resume Next
  ' If error occurs, Item should be Nothing
  
  Set Item = mCol.Item(vIndexKey)

End Property

Public Property Get Count() As Long
  
  Count = mCol.Count

End Property

Public Sub Remove(nIndex As Integer)
    
Dim oResource As clsResource
  
  On Error Resume Next
  
  Set oResource = mCol.Item(nIndex)
  
  mCol.Remove oResource.Key
  If Err.Number = 0 Then
    mlisResource.RemoveItem oResource.ListBoxIndex
    Set oResource = Nothing
  End If

End Sub

' For some reason, this doesn't work if uncommented
'----------------------------------------------------
'Public Property Get NewEnum() As IUnknown
'
'  Set NewEnum = mCol.[_NewEnum]
'
'End Property

Private Sub Class_Initialize()
    
  Set mCol = New Collection

End Sub

Private Sub Class_Terminate()
  
  Set mCol = Nothing

End Sub

Public Sub Construct(lisResource As ListBox)

  Set mlisResource = lisResource

End Sub

Public Property Get ResourceListBox() As ListBox

  Set ResourceListBox = mlisResource

End Property

Public Sub Clear()

  mlisResource.Clear
  mnKey = 0

  On Error Resume Next

  Do While mCol.Count > 0
    mCol.Remove 1
  Loop

End Sub

Public Property Get SelCount() As Integer

  SelCount = mlisResource.SelCount

End Property
